<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax Poll DBV v3.18 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : APDBV-318
// URL : http://www.phpkobo.com/ajax-poll-dbv
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CSql {

	public static function query( $sql ) {
		if ( is_array($sql) ) {
			$sql = implode(" ",$sql);
		}
		return CDb::query($sql);
	}

	public static function clSelect( $sx ) {
		if ( !empty( $sx ) ) {
			$fx = array();
			foreach( $sx as $key => $field ) {
				if ( is_int( $key ) ) {
					$fx[] = "`" . $field . "`";
				} else {
					$fx[] = $key . " AS `" . $field . "`";
				}
			}
			$ret = implode( ", ", $fx );
		} else {
			$ret = '*';
		}
		return "SELECT " . $ret;
	}

	public static function clFrom( $tbl, $alias=null ) {
		return "FROM " . "`" . CDb::tblname($tbl) . "`"
			. ($alias ? " AS {$alias}" : "");
	}

	public static function clCond( $f, $op, $v ) {
		if ( $op == 'L%%' ) {
			return "(`{$f}` LIKE '%" . CDb::sani($v) . "%')";
		} else {
			return "(`{$f}` {$op} " .
				( is_null($v) ? 'NULL' : "'" . CDb::sani($v) . "'" )
				. ")";
		}
	}

	public static function clWhere( $op, $cond ) {
		if ( count($cond) >= 1 ) {
			$cond = "(" . implode(" {$op} ", $cond ) . ")";
		}
		return "WHERE " . $cond;
	}

	public static function clInsert( $tbl, $dx ) {
		$fx = array();
		$vx = array();
		foreach( $dx as $key => $val ) {
			$fx[] = "`" . $key . "`";
			$vx[] = is_null($val) ? 'NULL' :
				"'" . CDb::sani($val) . "'";
		}
		return "INSERT INTO `" . CDb::tblname($tbl) . "` " .
			"(" . implode( ", ", $fx ) . ") VALUES " . 
			"(" . implode( ", ", $vx ) . ")";
	}

	public static function clUpdate( $tbl, $dx ) {
		$sx = array();
		foreach( $dx as $key => $val ) {
			if ( is_int( $key ) ) {
				$sx[] = $val;
			} else {
				$sx[] = "`" . $key . "`" . " = " .
					( is_null($val) ? 'NULL' :
					"'" . CDb::sani( $val ) . "'" );
			}
		}
		return "UPDATE `" . CDb::tblname($tbl) . "` " .
			"SET " . implode( ", ", $sx );
	}

	public static function clDelete( $tbl ) {
		return "DELETE FROM " . "`" . CDb::tblname($tbl) . "`";
	}
}

?>