<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax Poll DBV v3.18 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : APDBV-318
// URL : http://www.phpkobo.com/ajax-poll-dbv
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
class CFormVld {
	private static $fm;
	private static $vx;
	private static $lca;
	public static function init( $data, &$lca ) {
		if(!isset($data->requ["form"])){
			$data->resp["result"]="Assert Failed in CFormVid::init()";
			return false;
		}
		$data->fm = $data->requ["form"];
		$data->vx = array();
		self::setup($data->fm,$data->vx,$lca);
		return true;
	}
	public static function setup( &$fm, &$vx, &$lca ) {
		self::$fm =& $fm;
		self::$vx =& $vx;
		self::$lca =& $lca;
	}
	public static function isValidDateTime( $v ) {
		$t = strtotime($v);
		return !(( $t === false ) || ( strlen($v) <=1 ));
	}
	public static function isValidEmailAddr( $v ) {
		$s = trim( $v );
		if ( $s  != "" ) {
			$p1 = mb_strpos( $s, "@" );
			$p2 = mb_strrpos( $s, "." );
			if (
				( $p1  <= 0 )  ||
				( mb_strlen( $s )-1 <= $p2 ) ||
				( $p2  - $p1  <= 1 ) ||
				( mb_strpos($s ," " ) !== false )
			) {
				return false;
			}
		}
		return true;
	}
	public static function isValidInt( $v ) {
		return ( preg_match('/^[0-9]*$/', $v) == true );
	}
	public static function isValidFloat( $v ) {
		return ( preg_match('/^[0-9]*(\.[0-9]*)?$/', $v) == true );
	}
	public static function isValidURL( $v ) {
		return ( preg_match('/^(http:\/\/|https:\/\/).{1}/', $v) == true );
	}
	public static function copy( $key ) {
		if ( empty(self::$fm[$key]) ) {
			self::clear($key);
		} else {
			self::$vx[$key] = self::$fm[$key];
		}
	}
	public static function clear( $key ) {
		self::$vx[$key] = null;
	}
	public static function vCheckbox( $key, $b_assign = true ) {
		$val = ( intval(self::$fm[$key]) == 1 ) ? 1 : 0;
		if ( $b_assign ) {
			self::$vx[$key] = $val;
		}
		return $val;
	}
	public static function vStr( $key, $b_required = true, $b_assign = true ) {
		if ( empty(self::$fm[$key]) ) {
			if ( $b_required ) {
				self::setStateError($key);
				self::addAlertError(self::$lca["err:empty:{$key}"]);
			}
		}
		if ( $b_assign ) {
			self::copy($key);
		}
	}
	public static function vInt( $key, $b_required = true, $b_assign = true ) {
		if ( trim(self::$fm[$key]) == "" ) {
			if ( $b_required ) {
				self::setStateError($key);
				self::addAlertError(self::$lca["err:empty:{$key}"]);
			}
		} else if ( !self::isValidInt(self::$fm[$key]) ) {
			self::setStateError($key);
			self::addAlertError(self::$lca["err:invalid:{$key}"]);
		}
		if ( $b_assign ) {
			self::$vx[$key] = intval(trim(self::$fm[$key]));
		}
	}
	public static function vFloat( $key, $b_required = true, $b_assign = true ) {
		if ( trim(self::$fm[$key]) == "" ) {
			if ( $b_required ) {
				self::setStateError($key);
				self::addAlertError(self::$lca["err:empty:{$key}"]);
			}
		} else if ( !self::isValidFloat(self::$fm[$key]) ) {
			self::setStateError($key);
			self::addAlertError(self::$lca["err:invalid:{$key}"]);
		}
		if ( $b_assign ) {
			self::$vx[$key] = floatval(trim(self::$fm[$key]));
		}
	}
	public static function vDateTime( $key, $b_required = true, $b_assign = true ) {
		if ( empty(self::$fm[$key]) ) {
			if ( $b_required ) {
				self::setStateError($key);
				self::addAlertError(self::$lca["err:empty:{$key}"]);
			}
		} else if ( !self::isValidDateTime(self::$fm[$key]) ) {
			self::setStateError($key);
			self::addAlertError(self::$lca["err:invalid:{$key}"]);
		}
		if ( $b_assign ) {
			self::copy($key);
		}
	}
	public static function vEmail( $key, $b_required = true, $b_assign = true ) {
		if ( empty(self::$fm[$key]) ) {
			if ( $b_required ) {
				self::setStateError($key);
				self::addAlertError(self::$lca["err:empty:{$key}"]);
			}
		} else if ( !self::isValidEmailAddr(self::$fm[$key]) ) {
			self::setStateError($key);
			self::addAlertError(self::$lca["err:invalid:{$key}"]);
		}
		if ( $b_assign ) {
			self::copy($key);
		}
	}
	public static function vURL( $key, $b_required = true, $b_assign = true ) {
		if ( empty(self::$fm[$key]) ) {
			if ( $b_required ) {
				self::setStateError($key);
				self::addAlertError(self::$lca["err:empty:{$key}"]);
			}
		} else if ( !self::isValidURL(self::$fm[$key]) ) {
			self::setStateError($key);
			self::addAlertError(self::$lca["err:invalid:{$key}"]);
		}
		if ( $b_assign ) {
			self::copy($key);
		}
	}
	public static function v01( $key, $b_required = true, $b_assign = true ) {
		if ( isset(self::$fm[$key]) ) {
			$val = self::$fm[$key];
			if (( $val === "0" ) || ( $val === 0 )) {
				$val = 0;
			} else if (( $val === "1" ) || ( $val === 1 )) {
				$val = 1;
			} else {
				$val = null;
			}
		} else {
			$val = null;
		}

		if ( $b_required && ( is_null($val) )) {
			self::setStateError($key);
			self::addAlertError(self::$lca["err:empty:{$key}"]);
		}
		if ( $b_assign ) {
			self::$vx[$key] = $val;
		}
	}
	public static function vStrConf( $key ) {
		if ( empty(self::$fm["{$key}_conf"]) ) {
			//-- conf
			self::setStateError("{$key}_conf");
			self::addAlertError(self::$lca["err:empty:{$key}_conf"]);
		} else if ( self::$fm[$key] != self::$fm["{$key}_conf"] ) {
			//-- match
			self::setStateError($key);
			self::setStateError("{$key}_conf");
			self::addAlertError(self::$lca["err:cannot-confirm:{$key}"]);
		}
	}
	//-------------------------------------------------------
	// State & Alert
	//-------------------------------------------------------
	private static $b_validated = true;
	private static $fstate = array();
	private static $falert = array();
	private static $nmsg = "";
	private static $ntype = "";
	public static function setState( $field, $fs ) {
		// fs: error, success, warning
		self::$fstate[$field] = $fs;
		if ( $fs == "error" ) {
			self::$b_validated = false;
		}
	}
	public static function addAlert( $msg, $atype ) {
		// atype: error, success, info
		self::$falert[] = array(
			"atype"=>$atype,
			"msg"=>$msg,
		);
		if ( $atype == "error" ) {
			self::$b_validated = false;
		}
	}
	// error state
	public static function setStateError( $field ) {
		self::setState( $field, "error" );
	}
	// error alert
	public static function addAlertError( $msg ) {
		self::addAlert( $msg, "error" );
	}
	public static function setNotice( $nmsg, $ntype ) {
		// ntype: error, success
		self::$nmsg = $nmsg;
		self::$ntype = $ntype;

		if ( $ntype == "error" ) {
			self::$b_validated = false;
		}
	}
	// error notice
	public static function setNoticeError( $nmsg ) {
		self::setNotice( $nmsg, "error" );
	}
	// success notice
	public static function setNoticeSuccess( $nmsg ) {
		self::setNotice( $nmsg, "success" );
	}
	public static function isValidated() {
		return self::$b_validated;
	}
	public static function getFVldResult() {
		return array(
			"validated" => self::isValidated() ? 1 : 0,
			"fstate" => self::$fstate,
			"falert" => self::$falert,
			"nmsg" => self::$nmsg,
			"ntype" => self::$ntype,
		);
	}
	public static function ret( $data ) {
		$data->resp["fvld"] = self::getFVldResult();
		$data->resp["result"] = "OK";
	}
}

?>