/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax Poll DBV v3.18 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : APDBV-318
// URL : http://www.phpkobo.com/ajax-poll-dbv
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/
"use strict";
//-----------------------------------------------------------------
// IE-polyfill
//-----------------------------------------------------------------
// ChildNode.remove()
if(!('remove' in Element.prototype)){
	Element.prototype.remove=function(){
		if(this.parentNode){
			this.parentNode.removeChild(this);
		}
	};
}
// Element.closest()
if(!Element.prototype.matches){
	Element.prototype.matches=
		Element.prototype.msMatchesSelector||
		Element.prototype.webkitMatchesSelector;
}
if(!Element.prototype.closest){
	Element.prototype.closest=function(s){
		var el=this;
		do{
			if(Element.prototype.matches.call(el,s)){return el;}
			el=el.parentElement||el.parentNode;
		}while((el!==null)&&(el.nodeType===1));
		return null;
	};
}
// <template> tag
function instanciateTemplateById(id){
	var t=document.getElementById(id);
	if('content' in t){
		return document.importNode(t.content,true);
	}else{
		var el_tmp=document.createElement("div");
		el_tmp.innerHTML=t.innerHTML;
		return el_tmp.children[0];
	}
};
//-----------------------------------------------------------------
// Type/Feature Detection
//-----------------------------------------------------------------
function isFireFox(){
	return (navigator.userAgent.toLowerCase().indexOf('firefox')>-1);
};
function isIE(){
	var ua=window.navigator.userAgent;
	var msie=ua.indexOf("MSIE ");
	// Trident/7.0; rv:11.0
	return ((msie>0)||!!ua.match(/Trident.*rv\:11\./));
};
function isTouchDevice(){
	return(("ontouchstart" in window)
		||(navigator.MaxTouchPoints>0)
		||(navigator.msMaxTouchPoints>0));
};
function supportsScrollBehavior(){
	return('scrollBehavior' in document.documentElement.style);
};
//-----------------------------------------------------------------
// Utilities
//-----------------------------------------------------------------
// jQuery.offset
function offset(el){
	if(el==document.body){
		return {top:0,left:0};
	}else{
		var os=offset(el.offsetParent);
		return {top:os.top+el.offsetTop,left:os.left+el.offsetLeft};
	}
};
// php htmlspecialchars
function htmlEscape(str){
	var map={
		'&':'&amp;',
		'<':'&lt;',
		'>':'&gt;',
		'"':'&quot;',
		"'":'&#039;'
	};
	return str.replace(/[&<>"']/g,function(x){return map[x];});
};
// base64 encoding for <a> and <img>
function base64_encode(str){
	return btoa(unescape(encodeURIComponent(str)));
};
// protect a webpage form drag-and-drop
function preventFileDrop(){
	document.addEventListener("dragover",function(e){
		e.preventDefault();
	});
	document.addEventListener("drop",function(e){
		e.preventDefault();
	});
};
// send JSON by Ajax
function sendAjax(url_server,requ,callback,sender){
	var xhr=new XMLHttpRequest();
	xhr.open("POST",url_server,true);
	xhr.setRequestHeader("Content-Type",
		"application/x-www-form-urlencoded; charset=UTF-8");
	xhr.addEventListener("load",function(){
		if (xhr.status==200){
			var resp=JSON.parse(xhr.responseText);
			if (resp.result=="OK"){
				if(callback){
					if(sender){
						callback.call(sender,resp);
					}else{
						callback(resp);
					}
				}
			}else{
				console.log(resp.result);
			}
		}else{
			var s="";
			s+="status:"+xhr.status+"\n";
			s+="statusText:"+xhr.statusText;
			console.log(s);
		}
	});
	xhr.send("requ="+encodeURIComponent(JSON.stringify(requ)));
};
// copy to clipboard
function copyToClipboard(text){
	try {
		if(window.clipboardData&&window.clipboardData.setData){
			// IE specific code path to prevent textarea being shown while dialog is visible.
			return clipboardData.setData("Text",text); 
		}else if(document.queryCommandSupported&&document.queryCommandSupported("copy")){
			var textarea = document.createElement("textarea");
			textarea.textContent=text;
			// Prevent scrolling to bottom of page in MS Edge.
			textarea.style.position="fixed";
			document.body.appendChild(textarea);
			textarea.select();
			try {
				return document.execCommand("copy");
			}catch(ex){
				return false;
			}finally{
				document.body.removeChild(textarea);
			}
			return true;
		}else{
			return false;
		}
	}catch(ex){
		return false;
	}
	return true;
};
//-----------------------------------------------------------------
// Shorthands
//-----------------------------------------------------------------
function $(selector,el_ref){
	return (el_ref?el_ref:document).querySelector(selector);
};
function $$(selector,el_ref){
	return (el_ref?el_ref:document).querySelectorAll(selector);
};
function $id(id){
	return document.getElementById(id);
};
function $ce(tagName){
	return document.createElement(tagName);
};
