<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax Poll DBV v3.18 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : APDBV-318
// URL : http://www.phpkobo.com/ajax-poll-dbv
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
class CHandlers{
	public function __construct($evs){
		$evs->bind("next","hd_next",$this);
		$evs->bind("prev","hd_prev",$this);
		$evs->bind("reload","hd_reload",$this);
	}
	public function hd_next($data){
		$data->dir="next";
		$org=$data->requ["org"];
		switch($org){
		case "start":$this->page_permcheck($data);break;
		case "permcheck":$this->page_dbsetup($data);break;
		case "dbsetup":$this->process($data);break;
		default:
			$data->resp["result"]="ERROR:invalid org(".$org.")";
		}
	}
	public function hd_prev($data){
		$data->dir="prev";
		$org=$data->requ["org"];
		switch($org){
		case "permcheck":$this->page_start($data);break;
		case "dbsetup":$this->page_permcheck($data);break;
		default:
			$data->resp["result"]="ERROR:invalid org(".$org.")";
		}
	}
	public function hd_reload($data){
		$data->dir="reload";
		$org=$data->requ["org"];
		switch($org){
		case "permcheck":$this->page_permcheck($data);break;
		default:
			$data->resp["result"]="ERROR:invalid org(".$org.")";
		}
	}
	public function page_start($data){
		// load 'start' page
		$data->resp["page"]=array(
			"name"=>"start",
			"html"=>CTpl::load("page.start"),
			"dir"=>$data->dir,
		);
		// ok
		$data->resp["result"]="OK";
	}
	public function page_permcheck($data){
		// load 'permcheck' page
		$data->resp["page"]=array(
			"name"=>"permcheck",
			"html"=>CTpl::load("page.permcheck"),
			"dir"=>$data->dir,
		);
		// ok
		$data->resp["result"]="OK";
	}
	public function page_persoinfo($data){
		// load 'persoinfo' page
		$data->resp["page"]=array(
			"name"=>"persoinfo",
			"html"=>CTpl::load("page.persoinfo"),
			"dir"=>$data->dir,
		);
		// ok
		$data->resp["result"]="OK";
	}
	public function page_dbsetup($data){
		// load 'dbsetup' page
		$data->resp["page"]=array(
			"name"=>"dbsetup",
			"html"=>CTpl::load("page.dbsetup"),
			"dir"=>$data->dir,
		);
		// ok
		$data->resp["result"]="OK";
	}
	private static function setupDB($data){

		// path to sql file
		$path_sql=dirname(dirname(__FILE__)).
			"/sql/sql.txt";

		// path to db settings configuration file
		$path_dbcfg=dirname(dirname(CEnviro::get("path-ep"))).
			"/app.config/config.db.inc.php";

		// locale for dbsetup validation
		$lca=CLocale::get("install/page.dbsetup.validate");

		// check if the db config file is readable and writable
		if(!CConfigDbFile::checkPermission($path_dbcfg)){
			CFormVld::addAlertError($lca["err:can-not-write-config-db-file"]);
			CFormVld::ret($data);
			return false;
		}

		// copy form fields
		$vx=&$data->vx;
		$px=array();
		$px["db-hostname"]=$vx["db-hostname"];
		$px["db-database"]=$vx["db-database"];
		$px["db-username"]=$vx["db-username"];
		$px["db-password"]=$vx["db-password"];
		$px["db-tbl-prefix"]=$vx["db-tbl-prefix"];

		// setup database
		if(!CDBInstaller::run($px,$path_sql,$lca,$msg)){
			CFormVld::addAlertError($msg);
			CFormVld::ret($data);
			return false;
		}

		// save config file
		CConfigDbFile::save($path_dbcfg,$px);

		// success
		return true;
	}
	public function process($data){
		// validate form
		$lca=CLocale::get("install/page.dbsetup.validate");
		if(!CFormVld::init($data,$lca)){return;}
		CFormVld::vStr("db-hostname");
		CFormVld::vStr("db-database");
		CFormVld::vStr("db-username");
		CFormVld::vStr("db-password");
		CFormVld::vStr("db-tbl-prefix");
		if (!CFormVld::isValidated()){
			CFormVld::ret($data);
			return;
		}

		// setup database
		if(!$this->setupDB($data)){
			return;
		}

		// account info for admin panel
		//$vx=&$data->vx;
		//$account=array(
		//	"username"=>$vx["username"],
		//	"password"=>$vx["password"],
		//);
		//CAppSetup::run($account);
		$account=array(
			"username"=>"admin",
			"password"=>"password",
		);

		// success
		$this->page_done($data,$account);
	}
	public function page_done($data,$account){
		// load 'done' page
		$data->resp["page"]=array(
			"name"=>"done",
			"html"=>CTpl::load(
				"page.done",
				$account["username"],
				$account["password"]
			),
			"dir"=>$data->dir,
		);
		// ok
		$data->resp["result"]="OK";
	}
}

?>